src/main/java/com/android/vts/servlet/DashboardMainServlet.java
/*
 * Copyright (c) 2016 Google Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you
 * may not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package com.android.vts.servlet;

import com.android.vts.entity.TestEntity;
import com.android.vts.entity.TestStatusEntity;
import com.android.vts.entity.UserFavoriteEntity;
import com.google.appengine.api.datastore.DatastoreService;
import com.google.appengine.api.datastore.DatastoreServiceFactory;
import com.google.appengine.api.datastore.Entity;
import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.KeyFactory;
import com.google.appengine.api.datastore.PropertyProjection;
import com.google.appengine.api.datastore.Query;
import com.google.appengine.api.datastore.Query.Filter;
import com.google.appengine.api.datastore.Query.FilterOperator;
import com.google.appengine.api.datastore.Query.FilterPredicate;
import com.google.appengine.api.users.User;
import com.google.appengine.api.users.UserService;
import com.google.appengine.api.users.UserServiceFactory;
import com.google.gson.Gson;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;
import java.util.stream.Collectors;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import static com.googlecode.objectify.ObjectifyService.ofy;

/** Represents the servlet that is invoked on loading the first page of dashboard. */
public class DashboardMainServlet extends BaseServlet {
    private static final String DASHBOARD_MAIN_JSP = "WEB-INF/jsp/dashboard_main.jsp";
    private static final String NO_TESTS_ERROR = "No test results available.";

    @Override
    public PageType getNavParentType() {
        return PageType.TOT;
    }

    @Override
    public List<Page> getBreadcrumbLinks(HttpServletRequest request) {
        return null;
    }

    /** Helper class for displaying test entries on the main dashboard. */
    public class TestDisplay implements Comparable<TestDisplay> {
        private final Key testKey;
        private final int passCount;
        private final int failCount;
        private boolean muteNotifications;
        private boolean isFavorite;

        /**
         * Test display constructor.
         *
         * @param testKey The key of the test.
         * @param passCount The number of tests passing.
         * @param failCount The number of tests failing.
         * @param muteNotifications The flag for user notification in case of test failure.
         * @param isFavorite The flag for showing favorite mark on All Tests Tab page.
         */
        public TestDisplay(
                Key testKey,
                int passCount,
                int failCount,
                boolean muteNotifications,
                boolean isFavorite) {
            this.testKey = testKey;
            this.passCount = passCount;
            this.failCount = failCount;
            this.muteNotifications = muteNotifications;
            this.isFavorite = isFavorite;
        }

        /**
         * Get the key of the test.
         *
         * @return The key of the test.
         */
        public String getName() {
            return this.testKey.getName();
        }

        /**
         * Get the number of passing test cases.
         *
         * @return The number of passing test cases.
         */
        public int getPassCount() {
            return this.passCount;
        }

        /**
         * Get the number of failing test cases.
         *
         * @return The number of failing test cases.
         */
        public int getFailCount() {
            return this.failCount;
        }

        /**
         * Get the notification mute status.
         *
         * @return True if the subscriber has muted notifications, false otherwise.
         */
        public boolean getMuteNotifications() {
            return this.muteNotifications;
        }

        /** Set the notification mute status. */
        public void setMuteNotifications(boolean muteNotifications) {
            this.muteNotifications = muteNotifications;
        }

        /**
         * Get the favorate status.
         *
         * @return True if an user set favorate for the test, false otherwise.
         */
        public boolean getIsFavorite() {
            return this.isFavorite;
        }

        /** Set the favorite status. */
        public void setIsFavorite(boolean isFavorite) {
            this.isFavorite = isFavorite;
        }

        @Override
        public int compareTo(TestDisplay test) {
            return this.testKey.getName().compareTo(test.getName());
        }
    }

    @Override
    public void doGetHandler(HttpServletRequest request, HttpServletResponse response)
            throws IOException {
        UserService userService = UserServiceFactory.getUserService();
        User currentUser = userService.getCurrentUser();
        RequestDispatcher dispatcher = null;
        DatastoreService datastore = DatastoreServiceFactory.getDatastoreService();
        HttpSession session = request.getSession(true);
        PageType referTo = PageType.TREE;
        if (session.getAttribute("treeDefault") != null) {
            boolean treeDefault = (boolean) session.getAttribute("treeDefault");
            if (!treeDefault) {
                referTo = PageType.TABLE;
            }
        }

        List<TestDisplay> displayedTests = new ArrayList<>();
        List<Key> unprocessedTestKeys = new ArrayList<>();

        Map<Key, TestDisplay> testMap = new HashMap<>(); // map from table key to TestDisplay
        Map<String, String> subscriptionMap = new HashMap<>();

        boolean showAll = request.getParameter("showAll") != null;
        String error = null;

        List<String> allTestNames = TestEntity.getAllTestNames();

        List<Key> favoriteKeyList = new ArrayList<Key>();
        Filter userFilter =
                new FilterPredicate(UserFavoriteEntity.USER, FilterOperator.EQUAL, currentUser);
        Query filterQuery = new Query(UserFavoriteEntity.KIND).setFilter(userFilter);
        Iterable<Entity> favoriteIter = datastore.prepare(filterQuery).asIterable();
        favoriteIter.forEach(
                fe -> {
                    Key testKey = UserFavoriteEntity.fromEntity(fe).testKey;
                    favoriteKeyList.add(testKey);
                    subscriptionMap.put(testKey.getName(), KeyFactory.keyToString(fe.getKey()));
                });

        Query query =
                new Query(TestStatusEntity.KIND)
                        .addProjection(
                                new PropertyProjection(TestStatusEntity.PASS_COUNT, Long.class))
                        .addProjection(
                                new PropertyProjection(TestStatusEntity.FAIL_COUNT, Long.class));
        for (Entity status : datastore.prepare(query).asIterable()) {
            TestStatusEntity statusEntity = TestStatusEntity.fromEntity(status);
            if (statusEntity == null) continue;
            Key testKey = KeyFactory.createKey(TestEntity.KIND, statusEntity.getTestName());
            boolean isFavorite = favoriteKeyList.contains(testKey);
            TestDisplay display = new TestDisplay(testKey, -1, -1, false, isFavorite);
            if (!unprocessedTestKeys.contains(testKey)) {
                display =
                        new TestDisplay(
                                testKey,
                                statusEntity.getPassCount(),
                                statusEntity.getFailCount(),
                                false,
                                isFavorite);
            }
            testMap.put(testKey, display);
        }

        if (testMap.size() == 0) {
            error = NO_TESTS_ERROR;
        }

        if (showAll) {
            for (Key testKey : testMap.keySet()) {
                displayedTests.add(testMap.get(testKey));
            }
        } else {
            if (testMap.size() > 0) {
                for (Entity favoriteEntity : favoriteIter) {
                    UserFavoriteEntity favorite = UserFavoriteEntity.fromEntity(favoriteEntity);
                    Key testKey = favorite.testKey;
                    if (!testMap.containsKey(testKey)) {
                        continue;
                    }
                    TestDisplay display = testMap.get(testKey);
                    display.setMuteNotifications(favorite.muteNotifications);
                    displayedTests.add(display);
                }
            }
        }
        displayedTests.sort(Comparator.naturalOrder());

        response.setStatus(HttpServletResponse.SC_OK);
        request.setAttribute("allTestsJson", new Gson().toJson(allTestNames));
        request.setAttribute("subscriptionMapJson", new Gson().toJson(subscriptionMap));
        request.setAttribute("testNames", displayedTests);
        request.setAttribute("showAll", showAll);
        request.setAttribute("error", error);
        request.setAttribute("resultsUrl", referTo.defaultUrl);
        dispatcher = request.getRequestDispatcher(DASHBOARD_MAIN_JSP);
        try {
            dispatcher.forward(request, response);
        } catch (ServletException e) {

src/main/java/com/android/vts/servlet/ShowCoverageServlet.java
/*
 * Copyright (c) 2016 Google Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you
 * may not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package com.android.vts.servlet;

import static com.googlecode.objectify.ObjectifyService.ofy;

import com.android.vts.entity.CoverageEntity;
import com.android.vts.entity.RoleEntity;
import com.android.vts.entity.TestEntity;
import com.android.vts.entity.TestRunEntity;
import com.android.vts.entity.UserEntity;
import com.google.appengine.api.datastore.DatastoreService;
import com.google.appengine.api.datastore.DatastoreServiceFactory;
import com.google.appengine.api.datastore.Entity;
import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.KeyFactory;
import com.google.appengine.api.datastore.Query;
import com.google.gson.Gson;
import com.googlecode.objectify.Ref;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.logging.Level;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet for handling requests to show code coverage.
 */
public class ShowCoverageServlet extends BaseServlet {

  private static final String COVERAGE_JSP = "WEB-INF/jsp/show_coverage.jsp";
  private static final String TREE_JSP = "WEB-INF/jsp/show_tree.jsp";

  @Override
  public PageType getNavParentType() {
    return PageType.TOT;
  }

  @Override
  public List<Page> getBreadcrumbLinks(HttpServletRequest request) {
    List<Page> links = new ArrayList<>();
    String testName = request.getParameter("testName");
    links.add(new Page(PageType.TABLE, testName, "?testName=" + testName));

    String startTime = request.getParameter("startTime");
    links.add(new Page(PageType.COVERAGE, "?testName=" + testName + "&startTime=" + startTime));
    return links;
  }

  @Override
  public void doGetHandler(HttpServletRequest request, HttpServletResponse response)
      throws IOException {
    RequestDispatcher dispatcher = null;

    String test = request.getParameter("testName");
    String timeString = request.getParameter("startTime");

    Boolean isModerator = false;
    String currentUserEmail = request.getAttribute("email").toString();
    Optional<UserEntity> userEntityOptional = Optional
        .ofNullable(UserEntity.getUser(currentUserEmail));
    if (userEntityOptional.isPresent()) {
      Ref refRole = Ref.create(RoleEntity.getRole("coverage-moderator"));
      isModerator = userEntityOptional.get().getRoles().contains(refRole);
    }

    // Process the time key requested
    long time = -1;
    try {
      time = Long.parseLong(timeString);
    } catch (NumberFormatException e) {
      request.setAttribute("testName", test);
      dispatcher = request.getRequestDispatcher(TREE_JSP);
      return;
    }

    com.googlecode.objectify.Key testKey = com.googlecode.objectify.Key
        .create(TestEntity.class, test);
    com.googlecode.objectify.Key testRunKey = com.googlecode.objectify.Key
        .create(testKey, TestRunEntity.class, time);

    List<CoverageEntity> coverageEntityList = ofy().load().type(CoverageEntity.class)
        .ancestor(testRunKey).list();

    Collections.sort(coverageEntityList, CoverageEntity.isIgnoredComparator);

    request.setAttribute("isModerator", isModerator);
    request.setAttribute("testName", request.getParameter("testName"));
    request.setAttribute("gerritURI", new Gson().toJson(GERRIT_URI));
    request.setAttribute("gerritScope", new Gson().toJson(GERRIT_SCOPE));
    request.setAttribute("clientId", new Gson().toJson(CLIENT_ID));
    request.setAttribute("startTime", request.getParameter("startTime"));
    request.setAttribute("coverageEntityList", coverageEntityList);

    dispatcher = request.getRequestDispatcher(COVERAGE_JSP);
    try {
      dispatcher.forward(request, response);
    } catch (ServletException e) {
      logger.log(Level.SEVERE, "Servlet Exception caught : ", e);
    }
  }
}

src/main/java/com/android/vts/servlet/ShowProfilingListServlet.java
/*
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you
 * may not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package com.android.vts.servlet;

import static com.googlecode.objectify.ObjectifyService.ofy;

import com.android.vts.entity.TestEntity;
import com.google.appengine.api.datastore.DatastoreService;
import com.google.appengine.api.datastore.DatastoreServiceFactory;
import com.google.appengine.api.datastore.Entity;
import com.google.appengine.api.datastore.Query;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.logging.Level;
import java.util.stream.Collectors;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet for handling requests to display profiling tests.
 */
public class ShowProfilingListServlet extends BaseServlet {

  private static final String PROFILING_LIST_JSP = "WEB-INF/jsp/show_profiling_list.jsp";

  @Override
  public PageType getNavParentType() {
    return PageType.PROFILING_LIST;
  }

  @Override
  public List<Page> getBreadcrumbLinks(HttpServletRequest request) {
    return null;
  }

  @Override
  public void doGetHandler(HttpServletRequest request, HttpServletResponse response)
      throws IOException {
    List<String> tests = ofy().load().type(TestEntity.class)
        .filter(TestEntity.HAS_PROFILING_DATA, true).list().stream()
        .sorted(Comparator.comparing(TestEntity::getTestName)).map(t -> t.getTestName())
        .collect(Collectors.toList());

    response.setStatus(HttpServletResponse.SC_OK);
    request.setAttribute("testNames", tests);
    RequestDispatcher dispatcher = request.getRequestDispatcher(PROFILING_LIST_JSP);
    try {
      dispatcher.forward(request, response);
    } catch (ServletException e) {
      logger.log(Level.SEVERE, "Servlet Excpetion caught : ", e);
    }
  }
}

src/main/webapp/WEB-INF/jsp/auth_error.jsp
<%--
  ~ Copyright (c) 2018 Google Inc. All Rights Reserved.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License"); you
  ~ may not use this file except in compliance with the License. You may
  ~ obtain a copy of the License at
  ~
  ~     http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
  ~ implied. See the License for the specific language governing
  ~ permissions and limitations under the License.
  --%>
<%@ page contentType='text/html;charset=UTF-8' language='java' %>
<%@ taglib prefix='fn' uri='http://java.sun.com/jsp/jstl/functions' %>
<%@ taglib prefix='c' uri='http://java.sun.com/jsp/jstl/core'%>

<html>
  <link rel='stylesheet' href='/css/dashboard_main.css'>
  <%@ include file='header.jsp' %>
  <body>

    <div class='container wide'>

      <div class="card-panel">
        <span class="red-text text-darken-2">
          <h3> Sorry! you got a wrong email account. </h3>
          <br/>
          You have to register an account to access dashboard.
        </span>
      </div>

    </div>
    <%@ include file='footer.jsp' %>
  </body>
</html>

src/main/webapp/WEB-INF/jsp/error_msg.jsp
<%--
  ~ Copyright (c) 2018 Google Inc. All Rights Reserved.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License"); you
  ~ may not use this file except in compliance with the License. You may
  ~ obtain a copy of the License at
  ~
  ~     http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
  ~ implied. See the License for the specific language governing
  ~ permissions and limitations under the License.
  --%>
<%@ page contentType='text/html;charset=UTF-8' language='java' %>
<%@ taglib prefix='fn' uri='http://java.sun.com/jsp/jstl/functions' %>
<%@ taglib prefix='c' uri='http://java.sun.com/jsp/jstl/core'%>

<html>
<link rel='stylesheet' href='/css/dashboard_main.css'>
<%@ include file='header.jsp' %>
<body>

<div class='container wide'>

    <div class="card-panel">
        <span class="red-text text-darken-2">
          <h3> <c:out value="${error_title}"></c:out> </h3>
          <br/>
          <c:out value="${error_message}"></c:out>
        </span>
    </div>

</div>
<%@ include file='footer.jsp' %>
</body>
</html>

src/main/webapp/WEB-INF/jsp/footer.jsp
<%--
  ~ Copyright (c) 2017 Google Inc. All Rights Reserved.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License"); you
  ~ may not use this file except in compliance with the License. You may
  ~ obtain a copy of the License at
  ~
  ~     http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
  ~ implied. See the License for the specific language governing
  ~ permissions and limitations under the License.
  --%>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>

<footer class="page-footer" style="height: 70px;">
  <div class="footer-copyright">
    <div class="container">
      © 2017 - The Android Open Source Project
    </div>
  </div>
</footer>

src/main/webapp/WEB-INF/jsp/header.jsp
<%--
  ~ Copyright (c) 2017 Google Inc. All Rights Reserved.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License"); you
  ~ may not use this file except in compliance with the License. You may
  ~ obtain a copy of the License at
  ~
  ~     http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
  ~ implied. See the License for the specific language governing
  ~ permissions and limitations under the License.
  --%>
<%@ page contentType='text/html;charset=UTF-8' language='java' %>
<%@ taglib prefix='c' uri='http://java.sun.com/jsp/jstl/core'%>

<head>
  <link rel='stylesheet' href='https://www.gstatic.com/external_hosted/materialize/all_styles-bundle.css'>
  <link rel='icon' href='https://www.gstatic.com/images/branding/googleg/1x/googleg_standard_color_32dp.png' sizes='32x32'>
  <link rel='stylesheet' href='https://fonts.googleapis.com/icon?family=Material+Icons'>
  <link rel='stylesheet' href='https://fonts.googleapis.com/css?family=Roboto:100,300,400,500,700'>
  <link rel='stylesheet' href='/css/navbar.css'>
  <link rel='stylesheet' href='/css/common.css'>
  <script src='https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js'></script>
  <script src='https://ajax.googleapis.com/ajax/libs/jqueryui/1.12.1/jquery-ui.min.js'></script>
  <script src='https://www.gstatic.com/external_hosted/materialize/materialize.min.js'></script>
  <script type='text/javascript'>
    if (${analyticsID}) {
        // Autogenerated from Google Analytics
        (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
            (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
            m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
        })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');
        ga('create', ${analyticsID}, 'auto');
        ga('send', 'pageview');
    }
  </script>
  <title>VTS Dashboard</title>
</head>
<body>
  <nav id='navbar'>
    <div class='nav-wrapper'>
      <a href='#' class='brand-logo center'>VTS Dashboard</a>
      <ul class='nav-list'>
        <c:forEach items='${navbarLinks}' var='link' varStatus='loop'>
          <li class='${loop.index == activeIndex ? "active" : ""}'>
            <a class='nav-list-item' href='${link.url}'>${link.name}</a>
          </li>
        </c:forEach>
      </ul>
      <ul class='right'><li>
        <a id='dropdown-button' class='dropdown-button btn red lighten-3' href='#' data-activates='dropdown'>
          ${email}
        </a>
      </li></ul>
      <ul id='dropdown' class='dropdown-content'>
        <li><a href='${logoutURL}'>Log out</a></li>
      </ul>
      <c:if test='${breadcrumbLinks != null}'>
        <div id='nav-sublist'>
          <c:forEach items='${breadcrumbLinks}' var='link'>
            <a href='${link.url}' class='nav-sublist-item breadcrumb'>${link.name}</a>
          </c:forEach>
        </div>
      </c:if>
    </div>
  </nav>
</body>

src/main/webapp/WEB-INF/jsp/show_performance_digest.jsp
<%--
  ~ Copyright (c) 2016 Google Inc. All Rights Reserved.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License"); you
  ~ may not use this file except in compliance with the License. You may
  ~ obtain a copy of the License at
  ~
  ~     http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
  ~ implied. See the License for the specific language governing
  ~ permissions and limitations under the License.
  --%>
<%@ page contentType='text/html;charset=UTF-8' language='java' %>
<%@ taglib prefix='fn' uri='http://java.sun.com/jsp/jstl/functions' %>
<%@ taglib prefix='c' uri='http://java.sun.com/jsp/jstl/core'%>

<html>
  <%@ include file="header.jsp" %>
  <link type='text/css' href='/css/datepicker.css' rel='stylesheet'>
  <link type='text/css' href='/css/show_performance_digest.css' rel='stylesheet'>
  <link rel='stylesheet' href='https://ajax.googleapis.com/ajax/libs/jqueryui/1.12.0/jquery-ui.css'>
  <script src='https://www.gstatic.com/external_hosted/moment/min/moment-with-locales.min.js'></script>
  <script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jqueryui/1.12.1/jquery-ui.min.js"></script>
  <body>
    <script type='text/javascript'>
        ONE_DAY = 86400000000;
        MICRO_PER_MILLI = 1000;

        function load() {
            var time = $('#date').datepicker('getDate').getTime() - 1;
            time = time * MICRO_PER_MILLI + ONE_DAY;  // end of day
            var ctx = '${pageContext.request.contextPath}';
            var link = ctx + '/show_performance_digest?profilingPoint=${profilingPointName}' +
                '&testName=${testName}' +
                '&startTime=' + time;
            if ($('#device-select').prop('selectedIndex') > 1) {
                link += '&device=' + $('#device-select').val();
            }
            window.open(link,'_self');
        }

        $(function() {
            var date = $('#date').datepicker({
                showAnim: "slideDown",
                maxDate: new Date()
            });
            date.datepicker('setDate', new Date(${startTime} / MICRO_PER_MILLI));
            $('#load').click(load);

            $('.date-label').each(function(i) {
                var label = $(this);
                label.html(moment(parseInt(label.html())).format('M/D/YY'));
            });
            $('select').material_select();
        });
    </script>
    <div class='wide container'>
      <div class='row card'>
        <div id='header-container' class='col s12'>
          <div class='col s12'>
            <h4>Daily Performance Digest</h4>
          </div>
          <div id='device-select-wrapper' class='input-field col s6 m3 offset-m6'>
            <select id='device-select'>
              <option value='' disabled>Select device</option>
              <option value='0' ${empty selectedDevice ? 'selected' : ''}>All Devices</option>
              <c:forEach items='${devices}' var='device' varStatus='loop'>
                <option value=${device} ${selectedDevice eq device ? 'selected' : ''}>${device}</option>
              </c:forEach>
            </select>
          </div>
          <input type='text' id='date' name='date' class='col s5 m2'>
          <a id='load' class='btn-floating btn-medium red right waves-effect waves-light'>
            <i class='medium material-icons'>cached</i>
          </a>
        </div>
      </div>
      <div class='row'>
        <c:forEach items='${tables}' var='table' varStatus='loop'>
          <div class='col s12 card summary'>
            <div class='col s3 valign'>
              <h5>Profiling Point:</h5>
            </div>
            <div class='col s9 right-align valign'>
              <h5 class="profiling-name truncate">${tableTitles[loop.index]}</h5>
            </div>
            ${table}
            <span class='profiling-subtitle'>
              ${tableSubtitles[loop.index]}
            </span>
          </div>
        </c:forEach>
      </div>
    </div>
    <%@ include file="footer.jsp" %>
  </body>
</html>